/*
  (c) 1998 netEstate (http://www.netestate.de/, info@netestate.de),
Michael Brunnbauer & Markus Hendel, Gesellschaft fuer Netzwerkkommunikation bR
Am Bluetenanger 8, 80995 Muenchen, Germany

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef PRIVATE_INCLUDE_general
#include "general.h"
#define PRIVATE_INCLUDE_general
#endif
#ifndef PRIVATE_INCLUDE_errorlib
#include "errorlib.h"
#define PRIVATE_INCLUDE_errorlib
#endif

#ifndef NOSERIALIZE
#ifndef PRIVATE_INCLUDE_serialize
#include "serialize.h"
#define PRIVATE_INCLUDE_serialize
#endif
#endif

/* FIXME: gcc version 2.95.2 broken
#ifndef INCLUDE_iostream
#include <iostream.h>
#define INCLUDE_iostream
#endif
#ifndef INCLUDE_iomanip
#include <iomanip.h>
#define INCLUDE_iomanip
#endif
#ifndef INCLUDE_fstream
#include <fstream.h>
#define INCLUDE_fstream
#endif
*/

class string_class;
class string
{
public:

#ifndef NOSERIALIZE
  static string_class s;
#endif

  char *zgr;
  unsigned long len;

  /* konstruktor */
  string();

  /* destruktor */
  ~string();

  /* copy-konstruktor */
  string(const string &);

  /* = ueberladen */
  string& operator=(const string &);

  /* += ueberladen */
  string& operator+=(const string &);

  /* [] ueberladen */
  char& operator[](unsigned long) const;

  /* konversion von char* nach string */
  string(const char*);

  /* konversion von string nach char* */
  operator char *() const;

  /* sonstiges */
  string word(unsigned int) const;
  unsigned int words() const;

};

#ifndef NOSERIALIZE
struct string_class : serialize
{
  string_class()
  {
    sername("string");
    seradd("zgr",SER_STRING,(unsigned long) &string::zgr,0);
    return;
  };
};
#endif

/* ausgabe in streams */
/* ostream& operator<<(ostream&, string&); */

/* +, ==, !=, += ueberladen */
string operator+(const string &, const string &);
string operator+(const char *,const string &);
string operator+(const string &,const char *);

int operator==(const string &, const string &);
int operator!=(const string &, const string &);
int operator==(const string &, const char *);
int operator!=(const string &, const char *);
int operator==(const char *, const string &);
int operator!=(const char *, const string &);

bool defined(const string &);
extern unsigned long string_mem;

